



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【找规律】HDU 4662——MU Puzzle</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【找规律】HDU 4662——MU Puzzle</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 13:45:08 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>来源：<a href="http://acm.hdu.edu.cn/showproblem.php?pid=4662" rel="external nofollow noreferrer">点击打开链接</a></p>
<p>这个题目的来源是人工智能领域MU猜想。比赛的时候也参考了相关资料，可是最后差一点没有把规律推出来。</p>
<p>注意到以下几个性质。第一，MI怎么变换M永远只能在第一位。第二，因为变换时只能在I和U之间变换，因此，除了第一个是M以外，后面如果有字符串不是U、I以内的话永远不可能变换得到。第三，U可以看成是3个I，无论是I先变换成U再操作还是转化成一定数量的I，最后再准换成一定数量的U即可，因此将所有的字母用I作为一般等价物进行交换即可。</p>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
#include &lt;cstring&gt;<br />
#include &lt;string&gt;<br />
using namespace std;

int main()<br />
{<br />
	int testcase;<br />
	cin&gt;&gt;testcase;<br />
	while(testcase--)<br />
	{<br />
		string p="MI";<br />
		int counti=1,countu=0,counti2=0,countu2=0,cm=0,pos=0;<br />
		string tar;<br />
		cin&gt;&gt;tar;<br />
		for(int i=0;i&lt;tar.length();i++)<br />
		{

			if(tar[i]=='M')<br />
			{<br />
				cm++;<br />
			}

			if(tar[i]=='I')<br />
			{<br />
				counti2++;<br />
			}

			if(tar[i]=='U')<br />
			{<br />
				countu2++;<br />
			}

		}

		if( cm==1 &amp;&amp; tar[0]=='M'&amp;&amp; (((countu2*3+counti2)%2==0 &amp;&amp; (countu2*3+counti2)%3!=0)||(countu2*3+counti2)==1))<br />
		{<br />
			pos=1;<br />
		}<br />
		else<br />
		{<br />
			pos=0;<br />
		}

		if(pos==0)<br />
		{<br />
			cout&lt;&lt;"No"&lt;&lt;endl;<br />
		}<br />
		else if(pos==1)<br />
			cout&lt;&lt;"Yes"&lt;&lt;endl;

	}

	return 0;<br />
}
</pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495wxm9z.html">Ubuntu 16&period;04 安装 arm-linux-gcc 嵌入式交叉编译环境 问题汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jgn2l9.html">hdu2888 二维RMQ</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ypj4jq.html">【Linux】基于Bind&lowbar;DLZ和MySQL数据的DNS搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xpg4r9.html">VCL主要框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xj6r68.html">&period;NET SOCKET通信编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j075m4q.html">IOS DLNA开发（CyberLink和PlatinumKit）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn3xv6q.html">Servlet页面间对象传递的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge30178.html">JPA 系列教程6-单向多对多</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m14zj8.html">【CSS3】内联、内部、外部样式，样式优先级、层叠、继承</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdy4k49.html">Bzoj2946：&lbrack;POI2000&rsqb; 最长公共子串</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgp64e8.html">eclipse下maven一些配置方法汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp7kn0q.html">【ES6】Generator&plus;Promise异步编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjpznj8.html">Android四大组件的简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv21wl19.html">有关ajax的理解；</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvznvg8.html">sql语句，加引号和不加引号的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql105kx9.html">Spark UI &lpar;基于Yarn&rpar; 分析与定制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnz1wxq.html">BZOJ3123&colon; &lbrack;Sdoi2013&rsqb;森林（启发式合并&amp;amp&semi;主席树）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxlorkdq.html">BZOJ 1700 &lbrack;Usaco2007 Jan&rsqb;Problem Solving 解题（单调DP）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kmvgp69.html">Search for a range&comma;   在一个可能有重复元素的有序序列里找到指定元素的起始和结束位置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qd5xw7v9.html">让PC版网站在移动端原样式显示</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwl6dwl9.html">苹果无sim卡激活</a>
			</li>
						<li><a href="https://www.batexi.com/a/902ovk4q.html">sql：将字符类型字段转换成数字并排序</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnodwrq.html">CodeForces 606C&Tab;Sorting Railway Cars（最长连续上升子序列）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2krjexq.html">【2-SAT】HDU3622-Bomb Game</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwl6jgz9.html">压测工具Siege</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkmky18.html">洛谷P1341 最受欢迎的奶牛</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gplp209.html">codeforces 85D D&period; Sum of Medians Vector的妙用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o47vjxq.html">Mysql报错 Cannot load from mysql&period;proc</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjmd20q.html">Visual Studio 2015创建Shared Project时出错</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o475l5q.html">Druid 连接泄漏监测</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
